import sys
from subprocess import Popen, PIPE
import subprocess
import inkex
import os
class Unfold:
    def __init__(self):
        stl_filename = inkex.sys.argv[1]
        #inkex.debug("stl_filename: "+stl_filename)
        if os.name=="nt":
            outname = "papercraft_unfold_output.svg"
            #remove old file if existent
            if os.path.exists(outname):
              os.remove(outname)
            if os.path.exists("unfold.exe.stackdump"):
              os.remove("unfold.exe.stackdump")
            #convert the STL to have a binary one and wait until conversion finished before running papercraft
            cmd = os.getcwd() + "\\papercraft\\STLConverter.exe" + " " + stl_filename
            p = Popen(cmd, shell=True, stdout=PIPE, stderr=PIPE)
            #inkex.debug(cmd)
            #inkex.debug("os.getcwd(): "+os.getcwd())
            #inkex.debug(os.path.splitext(stl_filename)[0])
            p.wait()
            cmd2 = os.getcwd() + "\\papercraft\\unfold.exe" + " < " + os.path.splitext(stl_filename)[0] + "-binary.stl > " + outname
            #inkex.debug("cmd2: "+cmd2)
            p2 = Popen(cmd2, shell=True, stdout=PIPE, stderr=PIPE)
            #inkex.debug(p2.communicate())
            p2.wait()
            if p2.returncode == 0:
              #inkex.debug("OK")			
              doc = inkex.etree.parse(os.getcwd() + "\\" + outname)
              doc.write(inkex.sys.stdout)
if __name__ == '__main__':
    gc = Unfold()